"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var chalk_1 = __importDefault(require("chalk"));
var ora_1 = __importDefault(require("ora"));
var path_1 = __importDefault(require("path"));
var download_1 = require("../utils/download");
var utils_1 = require("../utils");
var red = chalk_1.default.red, green = chalk_1.default.green;
function create(name, template) {
    return __awaiter(this, void 0, void 0, function () {
        var root, projectInfo, spinner, error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!utils_1.isValidPackageName(name))
                        process.exit(1);
                    if (!utils_1.isValidTemplateType(template))
                        process.exit(1);
                    root = path_1.default.resolve(name);
                    return [4 /*yield*/, utils_1.getProjectInfo(name)];
                case 1:
                    projectInfo = _a.sent();
                    projectInfo.category = projectInfo.template.category;
                    utils_1.createAppDir(name);
                    if (!utils_1.isSafeDirectory(name))
                        process.exit(1);
                    spinner = ora_1.default('Downloading please wait...');
                    spinner.start();
                    _a.label = 2;
                case 2:
                    _a.trys.push([2, 4, , 5]);
                    return [4 /*yield*/, download_1.downloadTemplate(projectInfo, name, template)];
                case 3:
                    _a.sent();
                    return [3 /*break*/, 5];
                case 4:
                    error_1 = _a.sent();
                    console.log();
                    console.log(red("Failed to download template " + projectInfo.template.path + ": " + error_1.message + "."));
                    process.exit(1);
                    return [3 /*break*/, 5];
                case 5:
                    // 简单模板不要重置 package.json
                    // if (template !== 'simple') {
                    //   generate(name, projectInfo);
                    // }
                    spinner.succeed("" + green('Template download successfully!'));
                    // spinner.start('Installing packages. This might take a couple of minutes.');
                    // await runInstall(name);
                    // spinner.succeed(`${green('All packages installed successfully!')}`);
                    console.log();
                    console.log(green("Success! Created " + name + " at " + root));
                    console.log();
                    return [2 /*return*/];
            }
        });
    });
}
exports.default = create;
