"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var chalk_1 = __importDefault(require("chalk"));
var ora_1 = __importDefault(require("ora"));
var cross_spawn_1 = __importDefault(require("cross-spawn"));
var publish_1 = require("../utils/publish");
var debug_1 = require("../utils/debug");
var green = chalk_1.default.green;
/**
 * 打包src && .debug 代码
 * @param argv
 */
function publish(argv) {
    return __awaiter(this, void 0, void 0, function () {
        var debugPath, spinner;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    debugPath = './.debug';
                    spinner = ora_1.default('start debug publish...');
                    spinner.start();
                    // 先运行一次 debug，重新生成 .debug
                    // 先删除 .debug 目录
                    return [4 /*yield*/, cross_spawn_1.default.sync('rm', ['-rf', debugPath])];
                case 1:
                    // 先运行一次 debug，重新生成 .debug
                    // 先删除 .debug 目录
                    _a.sent();
                    return [4 /*yield*/, debug_1.generateDebugDir()];
                case 2:
                    _a.sent();
                    // copy gulp file
                    return [4 /*yield*/, publish_1.generateGulpFile()];
                case 3:
                    // copy gulp file
                    _a.sent();
                    // copy src dir into .debug
                    return [4 /*yield*/, publish_1.copySrcFile()];
                case 4:
                    // copy src dir into .debug
                    _a.sent();
                    // yarn build
                    return [4 /*yield*/, cross_spawn_1.default.sync('npm', ['run', 'build'], {
                            stdio: 'inherit',
                        })];
                case 5:
                    // yarn build
                    _a.sent();
                    // build && publish
                    // await spawn.sync('npm', ['publish'], {
                    //   stdio: 'inherit',
                    // });
                    spinner.succeed("" + green('suite build successfully!'));
                    spinner.succeed("" + green('接下来需手动执行 npm publish 发布套件。'));
                    return [2 /*return*/];
            }
        });
    });
}
exports.default = publish;
