"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = __importDefault(require("fs"));
var download_1 = require("../download");
var index_1 = require("../index");
var generate_config_1 = __importDefault(require("./generate-config"));
var generate_index_1 = __importDefault(require("./generate-index"));
var generate_custom_field_1 = __importDefault(require("./generate-custom-field"));
var webpack_1 = __importDefault(require("webpack"));
var webpack_dev_server_1 = __importDefault(require("webpack-dev-server"));
var dev_1 = __importDefault(require("../../webpack/dev"));
// const baseFileArr = ['base', 'designer', 'runtime', 'types'];
// 所有内置控件大全
var componentNames = ['SelectField', 'TextField'];
function runDebug() {
    return __awaiter(this, void 0, void 0, function () {
        var devServer, port, host, webpackConfig, compiler;
        return __generator(this, function (_a) {
            devServer = dev_1.default.devServer;
            port = devServer.port, host = devServer.host;
            webpackConfig = __assign(__assign({}, dev_1.default), { entry: {
                    main: './.debug/index.ts',
                } });
            compiler = webpack_1.default(webpackConfig);
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    try {
                        var server = new webpack_dev_server_1.default(compiler, __assign({}, devServer));
                        server.listen(port, host, function (err) {
                            if (err) {
                                reject(err);
                            }
                            resolve();
                        });
                    }
                    catch (err) {
                        reject(err);
                    }
                })];
        });
    });
}
exports.runDebug = runDebug;
// 生成 .debug/index.ts 和 config.ts
function generateDebugDir() {
    return __awaiter(this, void 0, void 0, function () {
        var debugPath, entryPath, debugConfigPath, templateType;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    debugPath = './.debug';
                    entryPath = './.debug/index.ts';
                    debugConfigPath = './.debug/config.ts';
                    templateType = index_1.getTemplateType();
                    // 生成 .debug/index.ts
                    if (!fs_1.default.existsSync(entryPath)) {
                        fs_1.default.mkdirSync(debugPath);
                        fs_1.default.writeFileSync(entryPath, generate_index_1.default());
                    }
                    if (!!fs_1.default.existsSync(debugConfigPath)) return [3 /*break*/, 2];
                    return [4 /*yield*/, download_1.downloadDebugTemplate()];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2:
                    // 高级模式需根据配置，动态生成自定义控件
                    if (templateType === 'advanced') {
                        generate_custom_field_1.default();
                    }
                    // 生成 .debug/config.ts，需要拿用户的 config transform
                    fs_1.default.writeFileSync(debugConfigPath, generate_config_1.default());
                    return [2 /*return*/];
            }
        });
    });
}
exports.generateDebugDir = generateDebugDir;
function listenConfigJsonFile() {
    return __awaiter(this, void 0, void 0, function () {
        var debugConfigPath, configJsonFile;
        return __generator(this, function (_a) {
            debugConfigPath = './.debug/config.ts';
            configJsonFile = './src/config.json';
            if (fs_1.default.existsSync(configJsonFile)) {
                // 监听 config.json 改变，重新生成 config.ts
                fs_1.default.watchFile(configJsonFile, function () {
                    var configData = generate_config_1.default();
                    if (configData) {
                        fs_1.default.writeFileSync(debugConfigPath, configData);
                    }
                });
            }
            return [2 /*return*/];
        });
    });
}
exports.listenConfigJsonFile = listenConfigJsonFile;
