import { ITemplateType } from '../constants';
export declare function isSafeDirectory(projectName: string): boolean;
export declare function isValidPackageName(name: string): boolean;
export declare function createAppDir(name: string): void;
export declare function getPackageManager(): 'yarn' | 'npm';
export declare function getGitAuthor(): {
    name: string;
    email: string;
};
export interface ProjectInfo {
    name: string;
    componentName: string;
    category: ITemplateType['category'];
    version: string;
    description: string;
    repository: string;
    author: string;
    license: string;
    template: ITemplateType;
    confirm: boolean;
}
export declare function getProjectInfo(name: string): Promise<ProjectInfo>;
export declare function isValidTemplateType(template: string): boolean;
export declare function isFile(filePath: string): boolean;
export declare function getTemplateType(): any;
export declare function isSimpleTemplate(): boolean;
export default function toCamel(str: string): string;
