"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = __importDefault(require("fs"));
var cross_spawn_1 = __importDefault(require("cross-spawn"));
function generateGulpFileContent() {
    return "const gulp = require('gulp');\nconst rimraf = require('rimraf');\nconst less = require('gulp-less');\nconst cssmin = require('gulp-clean-css');\nconst ts = require('gulp-typescript');\nconst plumber = require('gulp-plumber');\nconst alias = require('gulp-ts-alias');\nconst mapStream = require('map-stream');\n\nconst tsProject = ts.createProject('tsconfig.json');\n\nconst srcDir = ['./.debug/**/*.js', './.debug/**/*.ts', './.debug/**/*.tsx'];\nconst suiteConfig = require('./src/config.json');\nconst bizType = suiteConfig.bizType.replace(/[^a-zA-Z0-9]/gi,'');\n\ngulp.task('clean', async () => {\n  rimraf.sync('./lib');\n});\n\ngulp.task('compile-ts', () => {\n  return gulp\n    .src(srcDir)\n    .pipe(plumber())\n    .pipe(alias({ configuration: tsProject.config }))\n    .pipe(tsProject())\n    .pipe(plumber.stop())\n    .pipe(gulp.dest('lib'));\n});\n\ngulp.task('compile-less', () => {\n  return gulp\n    .src(['.debug/**/*.less'])\n    .pipe(mapStream(function(file,cb){\n      var fileContents = file.contents.toString(); \n      // ---\u5728\u8FD9\u91CC\u6267\u884C\u4EFB\u4F55\u5B57\u7B26\u4E32\u64CD\u4F5C--- \n      fileContents = '.' + bizType + '{' + fileContents + '}';\n      // -------------------- ------------------- \n      file.contents = new Buffer(fileContents); \n      cb(null,file); \n     }))\n    .pipe(less())\n    .pipe(cssmin())\n    .pipe(gulp.dest('lib'));\n});\n\ngulp.task('copy-less', () => {\n  return gulp\n    .src('.debug/**/*.less', { base: '.debug' })\n    .pipe(mapStream(function(file,cb){\n      var fileContents = file.contents.toString(); \n      // ---\u5728\u8FD9\u91CC\u6267\u884C\u4EFB\u4F55\u5B57\u7B26\u4E32\u64CD\u4F5C--- \n      fileContents = '.' + bizType + '{' + fileContents + '}';\n      // -------------------- ------------------- \n      file.contents = new Buffer(fileContents); \n      cb(null,file); \n     }))\n    .pipe(gulp.dest('lib'));\n});\n\ngulp.task('default', gulp.series('clean', 'compile-ts', 'compile-less', 'copy-less'));";
}
function generateGulpFile() {
    return __awaiter(this, void 0, void 0, function () {
        var gulpfilePath, gulpfileContent;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    gulpfilePath = './gulpfile.js';
                    // 先删除 gulpfile 目录
                    return [4 /*yield*/, cross_spawn_1.default.sync('rm', ['-rf', gulpfilePath])];
                case 1:
                    // 先删除 gulpfile 目录
                    _a.sent();
                    gulpfileContent = generateGulpFileContent();
                    if (gulpfileContent) {
                        fs_1.default.writeFileSync(gulpfilePath, gulpfileContent);
                    }
                    return [2 /*return*/];
            }
        });
    });
}
exports.generateGulpFile = generateGulpFile;
// src copy 到 .debug 下，.debug 作为 gulp src 入口
function copySrcFile() {
    return __awaiter(this, void 0, void 0, function () {
        var error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, cross_spawn_1.default.sync('cp', ['-R', "./src", "./.debug"])];
                case 1:
                    _a.sent();
                    return [3 /*break*/, 3];
                case 2:
                    error_1 = _a.sent();
                    console.error(error_1);
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    });
}
exports.copySrcFile = copySrcFile;
